logmode +addin

!doGUI = 1
!SaveTable = 1					'Save table as an RTF file to disk
%SaveName = "TblResults"	'Name of file to be saved
%SavePath = @wfpath			'Folder to save file in.  

if @len(@option(1)) then
	!doGUI = 0
	%temp = @equaloption("name")
	if @len(%temp) then
		%SaveName = %temp 
	endif
	%temp = @equaloption("path")
	if @len(%temp) then
		%SavePath = %temp 
	endif
endif
if !doGUI=1 then
	if !SaveTable=1 then
		!result= @uidialog("edit",%SaveName,"File name for output","edit",%SavePath,"Folder to put file",128)
		if !result=-1 then
			stop
		endif
	endif
endif

'check to see whether entered list of tables is a string object in the workfile:
%tblname =  _this.@name 
if @getthistype = "STRING" then
	%tblname = {%tblname}  
else if @neqna(@getthistype,"TABLE") = 1 then
		%error = %tblname + " is not a string object or table in your workfile" 		
		@uiprompt(%error)
		stop
	endif
endif

%tbl = @getnextname("_tbl")
freeze({%tbl}) _this.table
!nrows = 0
!ncols = 0
call gettablesize({%tbl}, !nrows, !ncols)
scalar nrows = !nrows
scalar ncols = !ncols

%textname = "LaTex"
if @isobject(%textname) = 1 then
%textname = @getnextname(%textname)
endif
text {%textname}

{%textname}.append "\documentclass[12pt]{article}"
{%textname}.append "\begin{document}"
{%textname}.append "\begin{table}"
{%textname}.append "\centering"
%ncol = ""
for !n=1 to !ncols
	%ncol = %ncol + "l |" 
next
%ncols = @wleft(%ncol,@wcount(%ncol)-1)
%cmd = "\begin{tabular}{" + %ncols +"}"
{%textname}.append %cmd
{%textname}.append "\hline \hline"

%special = "# & % $ _ { } \ ~ ^"
for !r=1 to !nrows
	for !c=1 to !ncols
		%temp = {%tbl}(!r,!c)
		for !i=1 to @wcount(%special)
			%cha = @word(%special,!i)
			if %cha = "\" then
				%temp = @replace(%temp, %cha, "$\backslash$")				
			else
				%temp = @replace(%temp, %cha, "\" + %cha)								
			endif
		next
		%str =  %temp + "& "		
		if !c=!ncols then
			%str = {%tbl}(!r,!c)
		endif
		{%textname}.append %str
	next
	{%textname}.append "\\"
next
{%textname}.append "\hline \hline"
{%textname}.append "\end{tabular}"
{%textname}.append "\end{table}"
{%textname}.append "\end{document}"

if !SaveTable=1 then
	%Savepath = @trim(%Savepath) 'remove spaces from the end of savepath
	
	if @length(%Savepath) = 0 then  'if no path was given, use default working path
		%Savepath = @temppath
	endif

	%last = @right(%Savepath,1) 
	if @neqna(%last,"\") then 'workout if the last character of the path is a slash, if not add one.
		%Savepath = %Savepath + "\"
	endif
	
	%Fullpath = %Savepath + @trim(%Savename) + ".tex"  'create full path and file name
	%Fullpath = @trim(%Fullpath)
	{%textname}.save %Fullpath 
endif

subroutine local gettablesize(table tab, scalar !nrows, scalar !ncols)
	'calculate table size
	!tol = 5  'number of empty cells to go through before deciding it is the end
	
	'find number of rows
	!keeprgoing = 1 
	!row = 1
	!numrblanks = 0
	!nrows = 0
	while !keeprgoing = 1 
		if tab(!row,1) = "" then
			!numrblanks = !numrblanks + 1
		else
			!numrblanks = 0
		endif
		if !numrblanks = !tol then
			!keeprgoing = 0
			!nrows = !row-!tol
		endif
		!row = !row + 1
	wend
	'find number of columns
	!maxncols = 0
	for !row = 1 to !nrows
		!ncols = 0
		!col = 1
		!keepcgoing = 1
		!numcblanks=0
		while !keepcgoing = 1
			'check current value
			if tab(!row,!col) = "" then
				!numcblanks = !numcblanks + 1
			else 
				!numcblanks = 0
			endif
			
			'check to see if tolerence met
			if !numcblanks=!tol then
				!keepcgoing = 0
				!ncols = !col-!tol
				if !ncols > !maxncols then
					!maxncols = !ncols
				endif
			endif
			!col = !col + 1
		wend
	next
	!ncols = !maxncols
endsub
